// These packing routines are based on the LZHUF.C program by
// Haruyasu Yoshizaki. Copyright (C) 1995 Christian Worm.

#include <suppack.h>
#include <suppack.hpp>
#include <stddef.h>

// This module equals CPPPACK - It's just for the unpacker. See
// CPPPACK for comments.

static int far pascal read(void far* userdata, char far *buffer,unsigned far* size) {
  return ((packing*)userdata)->read(buffer,size);
}

static int far pascal write(void far* userdata, char far* buffer, unsigned size) {
  return ((packing*)userdata)->write(buffer,size);
}

int packing::do_decode() {
  char* workbuffer=new char[decode_mem_req()];
  if(workbuffer==NULL) return PACK_NO_MEM;
  int a=::do_decode(this,::read,::write,workbuffer);
  delete workbuffer;
  return a;
}